// mex -O sendudp.c C:\pf\MATLAB\R2007a\sys\lcc\lib\wsock32.lib -DWIN32
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <winsock.h>

#include "mex.h"

#define SIZE 1272
#define NUM_FIR 25
#define DATAWIDTH 16
#define NUM_TRIANGLE 8

void usage(char *pgm){

	mexPrintf("%s <Dst. IP> <Dst. port> [Src IP] <input file> <output file>\n", pgm);
	exit(0);
}




//int main(int argc, char **argv)
//x = sendudp('10.0.0.51', uint32(port) , data);
void mexFunction(
    int           nlhs,           /* number of expected outputs */
    mxArray       *plhs[],        /* array of pointers to output arguments */
    int           nrhs,           /* number of inputs */
    const mxArray *prhs[]         /* array of pointers to input arguments */
    ) 

{
	WSADATA w;								/* Used to open Windows connection */
	unsigned short port_number;				/* The port number to use */
	SOCKET sd;								/* The socket descriptor */
	int server_length;						/* Length of server struct */
	short send_buffer[SIZE/2];		/* Data to send */
	int recv_buffer[SIZE/4];		/* Received data */
	struct hostent *hp;						/* Information about the server */
	struct hostent *he;						/* Information about the client */
	struct sockaddr_in server;				/* Information about the server */
	struct sockaddr_in client;				/* Information about the client */
//	int a1, a2, a3, a4;						/* Server address components in xxx.xxx.xxx.xxx form */
//	int b1, b2, b3, b4;						/* Client address components in xxx.xxx.xxx.xxx form */
	char host_name[256];					/* Host name of this computer */
	char server_name[256];					/* Host name of this computer */
    struct in_addr addr;                    /* Address of this computer */

	//FILE *fp_in, *fp_out;
	int i, j, len;
	long lSize;
	//size_t result;

      //time_t start;                /* Time measuring */
//      time_t stop;

  //    int counter;
  
	int mrows, ncols;
    short *xValues;
    int *yValues;
    
    unsigned short *portnum;

	int onewrite;
	int resultlen;
	int num_sym;
	int sumlen;
    
    

//    mexPrintf("Num of imputs : %d\n",nrhs);
//    mexPrintf("Num of expected outputs : %d\n", nlhs);
    
    mxGetString(prhs[0],server_name,255);
//    mexPrintf("IP : '%s'\n", server_name);
    

    portnum = mxGetPr(prhs[1]);
//    mexPrintf("Port : %d\n", *portnum);
    
    port_number=*portnum;
        
    
	/* Open windows connection */
	if (WSAStartup(0x0101, &w) != 0)
	{
		mexErrMsgTxt("Could not open Windows connection.\n");
		exit(0);
	}

	/* Open a datagram socket */
	sd = socket(AF_INET, SOCK_DGRAM, 0);
	if (sd == INVALID_SOCKET)
	{
		mexErrMsgTxt("Could not create socket.\n");
		WSACleanup();
		exit(0);
	}

	/* Clear out server struct */
	memset((void *)&server, '\0', sizeof(struct sockaddr_in));

	/* Set family and port */
	server.sin_family = AF_INET;
	server.sin_port = htons(port_number);
    
    /* Try IP address */
    addr.s_addr=inet_addr(server_name);
    if (addr.s_addr==INADDR_NONE){
        /*Can't resolve host string as dot notation IP number...
    	  try lookup IP from hostname */
        //	fprintf(stderr,"Trying nameserverlookup:%s\n",hostname);
        he=gethostbyname(server_name);
    	if(he==NULL){
            mexPrintf("\nUNKNOWN HOST:%s\n",server_name);
    	    exit(0);  /* Can not lookup hostname */
    	}
            addr = *((struct in_addr *)he->h_addr);
    }    

	/* Set server address */
    server.sin_addr=addr;

    /* Clear out client struct */
	memset((void *)&client, '\0', sizeof(struct sockaddr_in));

	/* Set family and port */
	client.sin_family = AF_INET;
	client.sin_port = htons(0);

		/* Get host name of this computer */
		gethostname(host_name, sizeof(host_name));
		hp = gethostbyname(host_name);

		/* Check for NULL pointer */
		if (hp == NULL)
		{
			mexErrMsgTxt("Could not get host name.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}

		/* Assign the address */
		client.sin_addr.S_un.S_un_b.s_b1 = hp->h_addr_list[0][0];
		client.sin_addr.S_un.S_un_b.s_b2 = hp->h_addr_list[0][1];
		client.sin_addr.S_un.S_un_b.s_b3 = hp->h_addr_list[0][2];
		client.sin_addr.S_un.S_un_b.s_b4 = hp->h_addr_list[0][3];

	/* Bind local address to socket */
	if (bind(sd, (struct sockaddr *)&client, sizeof(struct sockaddr_in)) == -1)
	{
		mexErrMsgTxt("Cannot bind address to socket.\n");
		closesocket(sd);
		WSACleanup();
		exit(0);
	}

	mrows = mxGetM(prhs[2]);
	ncols = mxGetN(prhs[2]);
	xValues = mxGetPr(prhs[2]);

  if(mrows*ncols*2+2>SIZE){
		mexErrMsgTxt("So much of data.\n");
		closesocket(sd);
		WSACleanup();
		exit(0);
  
  }

	//mexPrintf("Sending: \n");
	/*Prepare data*/
	for(i=0; i<ncols; i++){
	 for(j=0; j<mrows; j++){
    send_buffer[(i*mrows)+j+1]=xValues[(i*mrows)+j];
    //mexPrintf("%d : %d\n", xValues[(i*mrows)+j], send_buffer[(i*mrows)+j+1]);
    }
  }
  send_buffer[0]=0;
	//mexPrintf("\n");
		/* Tranmsit data */

		server_length = sizeof(struct sockaddr_in);
		if (sendto(sd, send_buffer, (int)ncols*mrows*sizeof(short)+2, 0, (struct sockaddr *)&server, server_length) == -1)
		{
			mexErrMsgTxt("Error transmitting data.\n");
			closesocket(sd);
			WSACleanup();
			exit(0);
		}


		/* Receive data */
    
		onewrite = (NUM_FIR*(2*DATAWIDTH/8));
		num_sym = (ncols*mrows) / NUM_TRIANGLE;//num of bytes/2 - 1(tag word)
		resultlen = num_sym * onewrite;
    sumlen=0;

    plhs[0] = mxCreateNumericMatrix(NUM_FIR /*row*/, num_sym/*col*/, mxINT32_CLASS ,mxREAL/*flag*/);
  	yValues = mxGetPr(plhs[0]);
    
    	
	  do{
  		len = recvfrom(sd, yValues+(sumlen/4)/*recv_buffer*/, SIZE, 0, (struct sockaddr *)&server, &server_length);
  		if (len < 0)
  		{
  			mexErrMsgTxt("Error receiving data.\n");
  			closesocket(sd);
  			WSACleanup();
  			exit(0);
  		}
  		sumlen+=len;
  		/*
      for(i=0; i<(int)(len/sizeof(unsigned long)); i++) {
        yValues[i]=recv_buffer[i];
        mexPrintf("%d : %d \n", recv_buffer[i], yValues[i]);
      }
		  */
		}while(sumlen!=resultlen);

	/* Create matrix for the return argument. */
	//plhs[0] = mxCreateDoubleMatrix(1 /*row*/, (int)(len/sizeof(unsigned long))/*col*/, mxREAL/*flag*/);


    //mexPrintf("Receiving: \n");
/*
  	for(i=0; i<(int)(len/sizeof(unsigned long)); i++) {
        yValues[i]=recv_buffer[i];
        //mexPrintf("%x : %x \n", recv_buffer[i], yValues[i]);
    }
*/


	closesocket(sd);
	WSACleanup();


}

